
#property copyright "Copyright  2009-2010, ForexBreakoutdroid.com"
#property link      "support@ForexBreakoutdroid.com"


extern int Buffer = 20;
extern double SL_multiplier = 0.8;
extern double TP_multiplier = 4.0;
extern string t = "Fixed lots... if Lot_size=0 then auto lots with Risk_percent!";
extern double Lot_size = 0.0;
extern int Risk_percent = 5;
extern int Friday_close_hour = 22;
extern string t1 = "TrailingStop & BreakEven in points... if =0 then disabled!";
extern int TrailingStop = 0;
extern int BreakEven = 3;
extern int BreakEvenAtProfit = 80;
extern string t2 = "AddIn positions... if AddInLotPercent=0 then disabled!";
extern int AddInLotPercent = 0;
extern double AddInMultiplier = 2.0;
extern double AddInSL_multiplier = 1.0;
extern double AddInTP_multiplier = 3.0;
extern int MaxTrades = 10;
extern bool OneDirection = FALSE;
int gi_188 = D'19.04.2001 06:25:21';
int gi_196;
int gi_200;
int gi_204;
int gi_208;
int gi_212;
int gi_216;
int gi_220;
int gi_224;
int gi_228;
int gi_232;
int gi_236;
int gi_240;
int gi_244 = 3;
double gd_248;
double gd_256;
double gd_264;
double gd_280;
double gd_288;

int init() {
   if (!GlobalVariableCheck("NextWeek") || IsTesting()) GlobalVariableSet("NextWeek", TimeCurrent());
   gi_228 = GlobalVariableGet("NextWeek");
   gi_236 = gi_228;
   if (Digits == 4 || Digits == 2 || Digits == 0) {
      gd_264 = Point;
      gi_216 = Digits;
   }
   if (Digits > 4) {
      gd_264 = 0.0001;
      gi_216 = 4;
   }
   if (Digits == 3) {
      gd_264 = 0.01;
      gi_216 = 2;
   }
   if (gd_264 == 0.0) gd_264 = Point;
   gd_248 = MarketInfo(Symbol(), MODE_MINLOT);
   gd_256 = MarketInfo(Symbol(), MODE_MAXLOT);
   gi_220 = MarketInfo(Symbol(), MODE_STOPLEVEL);
   
   switch (MarketInfo(Symbol(), MODE_LOTSTEP)) {
   case 0.01:
      gi_224 = 2;
      break;
   case 0.1:
      gi_224 = 1;
      break;
   default:
      gi_224 = 0;
   }
   return (0);
}

int deinit() {
   if (!IsTesting()) {
      Comment("");
      ObjectsDeleteAll(0, OBJ_ARROW);
   }
   return (0);
}

int start() {
   if (iBars(Symbol(), PERIOD_H4) < 30) {
      Print("Bars less then 30, please wait...");
      return (-1);
   }
   if (!IsLibrariesAllowed()) {
      Alert("You must allow import Library...");
      return (-1);
   }
   if (TimeCurrent() >= gi_228) {
      for (int li_0 = 0; TimeDayOfWeek(iTime(Symbol(), PERIOD_H4, li_0)) > 1; li_0++) {
      }
      while (TimeDayOfWeek(iTime(Symbol(), PERIOD_H4, li_0)) < 5) li_0++;
      li_0 -= 1;
      gi_232 = TimeCurrent() - iTime(Symbol(), PERIOD_H4, li_0);
      if (gi_232 > 14400 || li_0 > 0) {
         gd_280 = NormalizeDouble(iHigh(Symbol(), PERIOD_H4, li_0), gi_216);
         gd_288 = NormalizeDouble(iLow(Symbol(), PERIOD_H4, li_0), gi_216);
         gi_236 = TimeCurrent();
      } else {
         gi_236 = TimeCurrent() + 14401 - gi_232;
         return (1);
      }
      if (GlobalVariableSet("NextWeek", iTime(Symbol(), PERIOD_H4, li_0) + 518400) > 0) gi_228 = GlobalVariableGet("NextWeek");
      Print("Start of week ", TimeToStr(iTime(Symbol(), PERIOD_H4, li_0)), " ", li_0, " ", gd_280, " ", gd_288, " ", Bid);
   }
   if (DayOfWeek() == 5 && Hour() >= Friday_close_hour) {
      if (Check() > 0) {
         gi_212 = 9;
         Check();
         return (1);
      }
      gi_212 = 0;
      return (1);
   }
   if (DayOfWeek() == 5 && Hour() >= 23) {
      if (Check() > 0) {
         gi_212 = 99;
         Check();
         return (1);
      }
      gi_212 = 0;
      return (1);
   }
   if (TimeCurrent() >= gi_236) SetOrders();
   if (OneDirection) {
      if (gi_196 > 0 && gi_200 == 0) gi_212 = 999;
      if (gi_196 == 0 && gi_200 > 0) gi_212 = -999;
   }
   if (AddInLotPercent > 0) AddInOrders();
   if (TimeCurrent() >= gi_240) {
      if (gi_196 + gi_200 > 0) {
         gi_240 = TimeCurrent() + 300;
         trailingstop();
      }
   }
   Comment("Copyright  2009 ForexBreakoutDroid.com", 
      "\n", "ForexBreakoutDroid is running properly...", 
   "\n", "Account Equity", AccountEquity(), " Profit: ", AccountProfit());
   return (0);
}

int Check() {
   gi_196 = 0;
   gi_200 = 0;
   gi_204 = 0;
   gi_208 = 0;
   for (int li_0 = OrdersTotal() - 1; li_0 >= 0; li_0--) {
      if (OrderSelect(li_0, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == gi_188) {
            if (gi_212 == 9 && OrderType() < OP_BUYLIMIT) OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), gi_244, Black);
            else {
               if (gi_212 == 9 || gi_212 == 99 && OrderType() > OP_SELL) OrderDelete(OrderTicket(), Black);
               else {
                  if (OrderType() == OP_BUY) gi_196++;
                  else {
                     if (OrderType() == OP_SELL) gi_200++;
                     else {
                        if (OrderType() == OP_BUYLIMIT || OrderType() == OP_BUYSTOP) {
                           if (gi_212 == -999) OrderDelete(OrderTicket(), Black);
                           else gi_204 += 1;
                        } else {
                           if (OrderType() == OP_SELLLIMIT || OrderType() == OP_SELLSTOP) {
                              if (gi_212 == 999) OrderDelete(OrderTicket(), Black);
                              else gi_208 += 1;
                           }
                        }
                     }
                  }
               }
            }
         }
      }
   }
   return (gi_196 + gi_200 + gi_204 + gi_208);
}

double MM(double ad_0, int ai_8 = 100) {
   double ld_12;
   if (Lot_size <= 0.0) ld_12 = AccountFreeMargin() / 1000.0 * Risk_percent / ad_0;
   else ld_12 = Lot_size;
   ld_12 = NormalizeDouble(ai_8 / 100.0 * ld_12, gi_224);
   if (ld_12 < gd_248) ld_12 = gd_248;
   if (ld_12 > gd_256) ld_12 = gd_256;
   return (ld_12);
}

void SetOrders() {
   Check();
   double ld_0 = SL_multiplier * (gd_280 - gd_288) / gd_264;
   ld_0 = NormalizeDouble(ld_0, 0) + Buffer;
   double ld_8 = MM(ld_0);
   double ld_16 = TP_multiplier * (gd_280 - gd_288) / gd_264;
   ld_16 = NormalizeDouble(ld_16, 0);
   if (ld_16 < gi_220) ld_16 = gi_220;
   if (ld_0 < gi_220 + MarketInfo(Symbol(), MODE_SPREAD)) ld_0 = gi_220 + MarketInfo(Symbol(), MODE_SPREAD);
   if (gi_204 == 0) {
      if (gd_280 + Buffer * gd_264 - Ask >= gi_220 * gd_264) OrderSend(Symbol(), OP_BUYSTOP, ld_8, gd_280 + Buffer * gd_264, 3, gd_280 + Buffer * gd_264 - ld_0 * gd_264, gd_280 + Buffer * gd_264 + ld_16 * gd_264, "Breakout_EA", gi_188, 0, Green);
      if (Ask - (gd_280 + Buffer * gd_264) >= gi_220 * gd_264) OrderSend(Symbol(), OP_BUYLIMIT, ld_8, gd_280 + Buffer * gd_264, 3, gd_280 + Buffer * gd_264 - ld_0 * gd_264, gd_280 + Buffer * gd_264 + ld_16 * gd_264, "Breakout_EA", gi_188, 0, Green);
   }
   if (gi_208 == 0) {
      if (Bid - (gd_288 - Buffer * gd_264) >= gi_220 * gd_264) OrderSend(Symbol(), OP_SELLSTOP, ld_8, gd_288 - Buffer * gd_264, 3, gd_288 - Buffer * gd_264 + ld_0 * gd_264, gd_288 - Buffer * gd_264 - ld_16 * gd_264, "Breakout_EA", gi_188, 0, Purple);
      if (gd_288 - Buffer * gd_264 - Bid >= gi_220 * gd_264) OrderSend(Symbol(), OP_SELLLIMIT, ld_8, gd_288 - Buffer * gd_264, 3, gd_288 - Buffer * gd_264 + ld_0 * gd_264, gd_288 - Buffer * gd_264 - ld_16 * gd_264, "Breakout_EA", gi_188, 0, Purple);
   }
   Check();
   if (gi_204 == 1 && gi_208 == 1) gi_236 = gi_228;
   GetLastError();
}

void AddInOrders() {
   Check();
   double ld_0 = NormalizeDouble((gd_280 - gd_288) / gd_264 + Buffer, 0);
   double ld_8 = NormalizeDouble(Bid + AddInMultiplier * ld_0 * gd_264, Digits);
   double ld_16 = NormalizeDouble(Bid - AddInMultiplier * ld_0 * gd_264, Digits);
   double ld_24 = AddInSL_multiplier * ld_0;
   ld_24 = NormalizeDouble(ld_24, 0);
   double ld_32 = MM(ld_24, AddInLotPercent);
   double ld_40 = AddInTP_multiplier * ld_0;
   ld_40 = NormalizeDouble(ld_40, 0);
   if (ld_40 < gi_220) ld_40 = gi_220;
   if (ld_24 < gi_220 + MarketInfo(Symbol(), MODE_SPREAD)) ld_24 = gi_220 + MarketInfo(Symbol(), MODE_SPREAD);
   if (gi_196 > 0 && gi_204 < 1 && gi_196 < MaxTrades) OrderSend(Symbol(), OP_BUYSTOP, ld_32, ld_8, 3, ld_8 - ld_24 * gd_264, ld_8 + ld_40 * gd_264, "Breakout_EA_AddIn", gi_188, 0, Green);
   if (gi_200 > 0 && gi_208 < 1 && gi_200 < MaxTrades) OrderSend(Symbol(), OP_SELLSTOP, ld_32, ld_16, 3, ld_16 + ld_24 * gd_264, ld_16 - ld_40 * gd_264, "Breakout_EA_AddIn", gi_188, 0, Purple);
   GetLastError();
}

int trailingstop() {
   if (TrailingStop < 1 && BreakEven < 1) return (0);
   if (TrailingStop > 0 && TrailingStop < gi_220 + MarketInfo(Symbol(), MODE_SPREAD)) TrailingStop = gi_220 + MarketInfo(Symbol(), MODE_SPREAD);
   if (BreakEven > 0 && BreakEvenAtProfit - BreakEven < gi_220) BreakEvenAtProfit = BreakEven + gi_220;
   for (int li_0 = 0; li_0 < OrdersTotal(); li_0++) {
      OrderSelect(li_0, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol() || OrderType() > OP_SELL) continue;
      if (OrderMagicNumber() == gi_188) {
         if (OrderType() == OP_BUY) {
            if (BreakEven > 0 && OrderStopLoss() < OrderOpenPrice() + BreakEven * gd_264 && Ask >= OrderOpenPrice() + BreakEvenAtProfit * gd_264) {
               OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + BreakEven * gd_264, OrderTakeProfit(), 0, Gold);
               continue;
            }
            if (TrailingStop > 0 && OrderStopLoss() < Ask - TrailingStop * gd_264 && Ask >= OrderOpenPrice() + TrailingStop * gd_264) {
               OrderModify(OrderTicket(), OrderOpenPrice(), Ask - TrailingStop * gd_264, OrderTakeProfit(), 0, Gold);
               continue;
            }
         }
         if (OrderType() == OP_SELL) {
            if (BreakEven > 0 && OrderStopLoss() > OrderOpenPrice() - BreakEven * gd_264 || OrderStopLoss() == 0.0 && Bid <= OrderOpenPrice() - BreakEvenAtProfit * gd_264) OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - BreakEven * gd_264, OrderTakeProfit(), 0, Gold);
            else
               if (TrailingStop > 0 && OrderStopLoss() > Bid + TrailingStop * gd_264 || OrderStopLoss() == 0.0 && Bid <= OrderOpenPrice() - TrailingStop * gd_264) OrderModify(OrderTicket(), OrderOpenPrice(), Bid + TrailingStop * gd_264, OrderTakeProfit(), 0, Gold);
         }
      }
   }
   return (GetLastError());
}